diff --git a/testsuite/Makefile.am b/testsuite/Makefile.am
index d530f798fbed44806753f61b0d9f9e6112d901aa..a239440ce46174c3b8b29fd16be29f46c54516e8 100644
--- a/testsuite/Makefile.am
+++ b/testsuite/Makefile.am
@@ -19,17 +19,20 @@ TS_PROGS = aes-test arcfour-test blowfish-test cast128-test \
 	   dsa-test dsa-keygen-test \
 	   yarrow-test
 
-TS_SH = sexp-conv-test
+TS_SH = sexp-conv-test symbols-test
 
 TS_ALL = $(TS_PROGS) $(TS_SH)
 
 noinst_PROGRAMS = $(TS_PROGS)
 
+# Workaround to get automake to keep dependencies for testutils.o
+EXTRA_PROGRAMS = testutils
+
 # libnettle.a is added at the end to make sure all programs depend on it.
 # It seems there's no DEPENDENCIES variable that affects all programs.
 
 LDADD = testutils.o -lnettle ../libnettle.a
-EXTRA_DIST = $(TS_SH) testutils.c testutils.h \
+EXTRA_DIST = $(TS_SH) testutils.h \
 	     run-tests rfc1750.txt
 
 CLEANFILES = test.in test1.out test2.out
diff --git a/testsuite/symbols-test b/testsuite/symbols-test
new file mode 100755
index 0000000000000000000000000000000000000000..d6bd4840b3244c43ca19cb04d49301c1ceb7a098
--- /dev/null
+++ b/testsuite/symbols-test
@@ -0,0 +1,18 @@
+#! /bin/sh
+
+# Check that all exported symbols use the nettle prefix.
+
+if [ -z "$srcdir" ] ; then
+  srcdir=`pwd`
+fi
+
+nm ../libnettle.a | grep ' [DRT] ' | egrep -v ' _?nettle_|memxor' \
+    | sort -k3 > test1.out
+
+if [ -s test1.out ] ; then
+    echo Exported symbols lacking the nettle prefix:
+    cat test1.out
+    exit 1
+else
+    exit 0
+fi